# -*- encoding: utf-8 -*-

Gem::Specification.new do |s|
  s.name = %q{activeldap}
  s.version = "1.0.2"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.authors = ["Will Drewry", "Kouhei Sutou"]
  s.autorequire = %q{active_ldap}
  s.date = %q{2009-02-22}
  s.description = %q{'Ruby/ActiveLdap' is a ruby extension library which provides a clean objected oriented interface to the Ruby/LDAP library.  It was inspired by ActiveRecord. This is not nearly as clean or as flexible as ActiveRecord, but it is still trivial to define new objects and manipulate them with minimal difficulty.}
  s.email = ["redpig@dataspill.org", "kou@cozmixng.org"]
  s.extra_rdoc_files = ["examples/al-admin/public/robots.txt", "test-unit/History.txt", "test-unit/Manifest.txt", "test-unit/README.txt"]
  s.files = ["CHANGES", "COPYING", "LICENSE", "README", "Rakefile", "TODO", "benchmark/bench-al.rb", "benchmark/config.yaml.sample", "examples/al-admin/README", "examples/al-admin/Rakefile", "examples/al-admin/app/controllers/account_controller.rb", "examples/al-admin/app/controllers/application.rb", "examples/al-admin/app/controllers/attributes_controller.rb", "examples/al-admin/app/controllers/directory_controller.rb", "examples/al-admin/app/controllers/object_classes_controller.rb", "examples/al-admin/app/controllers/syntaxes_controller.rb", "examples/al-admin/app/controllers/users_controller.rb", "examples/al-admin/app/controllers/welcome_controller.rb", "examples/al-admin/app/helpers/account_helper.rb", "examples/al-admin/app/helpers/application_helper.rb", "examples/al-admin/app/helpers/attributes_helper.rb", "examples/al-admin/app/helpers/directory_helper.rb", "examples/al-admin/app/helpers/object_classes_helper.rb", "examples/al-admin/app/helpers/syntaxes_helper.rb", "examples/al-admin/app/helpers/url_helper.rb", "examples/al-admin/app/helpers/users_helper.rb", "examples/al-admin/app/helpers/welcome_helper.rb", "examples/al-admin/app/models/entry.rb", "examples/al-admin/app/models/ldap_user.rb", "examples/al-admin/app/models/user.rb", "examples/al-admin/app/views/_entry/_attributes_information.html.erb", "examples/al-admin/app/views/_entry/_entry.html.erb", "examples/al-admin/app/views/_schema/_aliases.html.erb", "examples/al-admin/app/views/_switcher/_after.html.erb", "examples/al-admin/app/views/_switcher/_before.html.erb", "examples/al-admin/app/views/account/login.html.erb", "examples/al-admin/app/views/account/sign_up.html.erb", "examples/al-admin/app/views/attributes/_attributes.html.erb", "examples/al-admin/app/views/attributes/_detail.html.erb", "examples/al-admin/app/views/attributes/index.html.erb", "examples/al-admin/app/views/attributes/show.html.erb", "examples/al-admin/app/views/directory/_tree.html.erb", "examples/al-admin/app/views/directory/_tree_view_js.html.erb", "examples/al-admin/app/views/directory/index.html.erb", "examples/al-admin/app/views/directory/populate.html.erb", "examples/al-admin/app/views/layouts/_footer.html.erb", "examples/al-admin/app/views/layouts/_header_menu.html.erb", "examples/al-admin/app/views/layouts/_main_menu.html.erb", "examples/al-admin/app/views/layouts/application.html.erb", "examples/al-admin/app/views/object_classes/_attributes.html.erb", "examples/al-admin/app/views/object_classes/_object_classes.html.erb", "examples/al-admin/app/views/object_classes/index.html.erb", "examples/al-admin/app/views/object_classes/show.html.erb", "examples/al-admin/app/views/syntaxes/_detail.html.erb", "examples/al-admin/app/views/syntaxes/_syntaxes.html.erb", "examples/al-admin/app/views/syntaxes/index.html.erb", "examples/al-admin/app/views/syntaxes/show.html.erb", "examples/al-admin/app/views/users/_attributes_update_form.html.erb", "examples/al-admin/app/views/users/_form.html.erb", "examples/al-admin/app/views/users/_object_classes_update_form.html.erb", "examples/al-admin/app/views/users/_password_change_form.html.erb", "examples/al-admin/app/views/users/edit.html.erb", "examples/al-admin/app/views/users/index.html.erb", "examples/al-admin/app/views/users/show.html.erb", "examples/al-admin/app/views/welcome/index.html.erb", "examples/al-admin/config/boot.rb", "examples/al-admin/config/database.yml.example", "examples/al-admin/config/environment.rb", "examples/al-admin/config/environments/development.rb", "examples/al-admin/config/environments/production.rb", "examples/al-admin/config/environments/test.rb", "examples/al-admin/config/initializers/exception_notifier.rb", "examples/al-admin/config/initializers/gettext.rb", "examples/al-admin/config/initializers/inflections.rb", "examples/al-admin/config/initializers/mime_types.rb", "examples/al-admin/config/ldap.yml.example", "examples/al-admin/config/routes.rb", "examples/al-admin/db/migrate/001_create_users.rb", "examples/al-admin/lib/authenticated_system.rb", "examples/al-admin/lib/authenticated_test_helper.rb", "examples/al-admin/lib/tasks/gettext.rake", "examples/al-admin/po/en/al-admin.po", "examples/al-admin/po/ja/al-admin.po", "examples/al-admin/po/nl/al-admin.po", "examples/al-admin/public/.htaccess", "examples/al-admin/public/404.html", "examples/al-admin/public/500.html", "examples/al-admin/public/dispatch.cgi", "examples/al-admin/public/dispatch.fcgi", "examples/al-admin/public/dispatch.rb", "examples/al-admin/public/favicon.ico", "examples/al-admin/public/images/active-ldap.svg", "examples/al-admin/public/images/al-admin.png", "examples/al-admin/public/images/al-admin.svg", "examples/al-admin/public/images/header-background.png", "examples/al-admin/public/images/header-background.svg", "examples/al-admin/public/images/rails.png", "examples/al-admin/public/images/spinelz/accordion_tab_left_active.gif", "examples/al-admin/public/images/spinelz/accordion_tab_left_inactive.gif", "examples/al-admin/public/images/spinelz/accordion_tab_middle_active.gif", "examples/al-admin/public/images/spinelz/accordion_tab_middle_inactive.gif", "examples/al-admin/public/images/spinelz/accordion_tab_right_active.gif", "examples/al-admin/public/images/spinelz/accordion_tab_right_inactive.gif", "examples/al-admin/public/images/spinelz/balloon_back.gif", "examples/al-admin/public/images/spinelz/balloon_bottom_left.gif", "examples/al-admin/public/images/spinelz/balloon_bottom_middle.gif", "examples/al-admin/public/images/spinelz/balloon_bottom_right.gif", "examples/al-admin/public/images/spinelz/balloon_left_down_arrow.gif", "examples/al-admin/public/images/spinelz/balloon_left_up_arrow.gif", "examples/al-admin/public/images/spinelz/balloon_middle_left.gif", "examples/al-admin/public/images/spinelz/balloon_middle_right.gif", "examples/al-admin/public/images/spinelz/balloon_right_down_arrow.gif", "examples/al-admin/public/images/spinelz/balloon_right_up_arrow.gif", "examples/al-admin/public/images/spinelz/balloon_top_left.gif", "examples/al-admin/public/images/spinelz/balloon_top_middle.gif", "examples/al-admin/public/images/spinelz/balloon_top_right.gif", "examples/al-admin/public/images/spinelz/barchart_h.gif", "examples/al-admin/public/images/spinelz/barchart_v.gif", "examples/al-admin/public/images/spinelz/button.gif", "examples/al-admin/public/images/spinelz/calendar_default_handler.gif", "examples/al-admin/public/images/spinelz/calendar_delete.gif", "examples/al-admin/public/images/spinelz/calendar_next.gif", "examples/al-admin/public/images/spinelz/calendar_next_second.gif", "examples/al-admin/public/images/spinelz/calendar_pre.gif", "examples/al-admin/public/images/spinelz/calendar_pre_second.gif", "examples/al-admin/public/images/spinelz/calendar_private_icon.gif", "examples/al-admin/public/images/spinelz/calendar_schedule.gif", "examples/al-admin/public/images/spinelz/calender_back.gif", "examples/al-admin/public/images/spinelz/calender_back_second.gif", "examples/al-admin/public/images/spinelz/datepicker2_back.gif", "examples/al-admin/public/images/spinelz/datepicker2_back_second.gif", "examples/al-admin/public/images/spinelz/datepicker2_next.gif", "examples/al-admin/public/images/spinelz/datepicker2_next_second.gif", "examples/al-admin/public/images/spinelz/datepicker2_pre.gif", "examples/al-admin/public/images/spinelz/datepicker2_pre_second.gif", "examples/al-admin/public/images/spinelz/datepicker_back.gif", "examples/al-admin/public/images/spinelz/datepicker_back_second.gif", "examples/al-admin/public/images/spinelz/datepicker_next.gif", "examples/al-admin/public/images/spinelz/datepicker_next_second.gif", "examples/al-admin/public/images/spinelz/datepicker_pre.gif", "examples/al-admin/public/images/spinelz/datepicker_pre_second.gif", "examples/al-admin/public/images/spinelz/grid_down.gif", "examples/al-admin/public/images/spinelz/grid_state.gif", "examples/al-admin/public/images/spinelz/grid_up.gif", "examples/al-admin/public/images/spinelz/icon_day.gif", "examples/al-admin/public/images/spinelz/icon_month.gif", "examples/al-admin/public/images/spinelz/icon_week.gif", "examples/al-admin/public/images/spinelz/menubar_back.gif", "examples/al-admin/public/images/spinelz/menubar_subcontents_back.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_left_active.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_left_inactive.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_middle_active.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_middle_inactive.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_right_active.gif", "examples/al-admin/public/images/spinelz/navPanel_tab_right_inactive.gif", "examples/al-admin/public/images/spinelz/select_date.gif", "examples/al-admin/public/images/spinelz/selectabletable_selected.gif", "examples/al-admin/public/images/spinelz/sideBarBox_about.gif", "examples/al-admin/public/images/spinelz/sideBarBox_menu.gif", "examples/al-admin/public/images/spinelz/sideBarBox_sample.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabBottomActive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabBottomInactive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabMiddleActive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabMiddleActive2.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabMiddleInactive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabMiddleInactive2.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabTopActive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabTopInactive.gif", "examples/al-admin/public/images/spinelz/sideBarBox_tabbar.gif", "examples/al-admin/public/images/spinelz/sortableTable_down.gif", "examples/al-admin/public/images/spinelz/sortableTable_normal.gif", "examples/al-admin/public/images/spinelz/sortableTable_up.gif", "examples/al-admin/public/images/spinelz/switcher_close.gif", "examples/al-admin/public/images/spinelz/switcher_open.gif", "examples/al-admin/public/images/spinelz/tabBox_close.gif", "examples/al-admin/public/images/spinelz/tabBox_tabLeftActive.gif", "examples/al-admin/public/images/spinelz/tabBox_tabLeftInactive.gif", "examples/al-admin/public/images/spinelz/tabBox_tabMiddleActive.gif", "examples/al-admin/public/images/spinelz/tabBox_tabMiddleInactive.gif", "examples/al-admin/public/images/spinelz/tabBox_tabRightActive.gif", "examples/al-admin/public/images/spinelz/tabBox_tabRightInactive.gif", "examples/al-admin/public/images/spinelz/tab_bar.gif", "examples/al-admin/public/images/spinelz/table_back.gif", "examples/al-admin/public/images/spinelz/timepicker_clock.gif", "examples/al-admin/public/images/spinelz/toolbar_close.gif", "examples/al-admin/public/images/spinelz/toolbar_left.gif", "examples/al-admin/public/images/spinelz/toolbar_max.gif", "examples/al-admin/public/images/spinelz/toolbar_middle.gif", "examples/al-admin/public/images/spinelz/toolbar_min.gif", "examples/al-admin/public/images/spinelz/toolbar_next.gif", "examples/al-admin/public/images/spinelz/toolbar_right.gif", "examples/al-admin/public/images/spinelz/treeview_dir.gif", "examples/al-admin/public/images/spinelz/treeview_file.gif", "examples/al-admin/public/images/spinelz/treeview_group.gif", "examples/al-admin/public/images/spinelz/treeview_group_special.gif", "examples/al-admin/public/images/spinelz/treeview_state.gif", "examples/al-admin/public/images/spinelz/treeview_user.gif", "examples/al-admin/public/images/spinelz/window_bottom_left.gif", "examples/al-admin/public/images/spinelz/window_bottom_middle.gif", "examples/al-admin/public/images/spinelz/window_bottom_right.gif", "examples/al-admin/public/images/spinelz/window_close.gif", "examples/al-admin/public/images/spinelz/window_max.gif", "examples/al-admin/public/images/spinelz/window_middle_left.gif", "examples/al-admin/public/images/spinelz/window_middle_right.gif", "examples/al-admin/public/images/spinelz/window_min.gif", "examples/al-admin/public/images/spinelz/window_top_left.gif", "examples/al-admin/public/images/spinelz/window_top_middle.gif", "examples/al-admin/public/images/spinelz/window_top_right.gif", "examples/al-admin/public/javascripts/application.js", "examples/al-admin/public/javascripts/controls.js", "examples/al-admin/public/javascripts/dragdrop.js", "examples/al-admin/public/javascripts/effects.js", "examples/al-admin/public/javascripts/prototype.js", "examples/al-admin/public/javascripts/spinelz/accordion.js", "examples/al-admin/public/javascripts/spinelz/ajaxHistory.js", "examples/al-admin/public/javascripts/spinelz/balloon.js", "examples/al-admin/public/javascripts/spinelz/barchart.js", "examples/al-admin/public/javascripts/spinelz/calendar.js", "examples/al-admin/public/javascripts/spinelz/colorpicker.js", "examples/al-admin/public/javascripts/spinelz/datepicker.js", "examples/al-admin/public/javascripts/spinelz/grid.js", "examples/al-admin/public/javascripts/spinelz/grid_resizeEx.js", "examples/al-admin/public/javascripts/spinelz/grid_sortabletableEx.js", "examples/al-admin/public/javascripts/spinelz/inplaceEditorEx.js", "examples/al-admin/public/javascripts/spinelz/menubar.js", "examples/al-admin/public/javascripts/spinelz/navPanel.js", "examples/al-admin/public/javascripts/spinelz/selectableTable.js", "examples/al-admin/public/javascripts/spinelz/sideBarBox.js", "examples/al-admin/public/javascripts/spinelz/sideBarBox_effects.js", "examples/al-admin/public/javascripts/spinelz/sortableTable.js", "examples/al-admin/public/javascripts/spinelz/switcher.js", "examples/al-admin/public/javascripts/spinelz/tabBox.js", "examples/al-admin/public/javascripts/spinelz/timepicker.js", "examples/al-admin/public/javascripts/spinelz/toolbar.js", "examples/al-admin/public/javascripts/spinelz/treeview.js", "examples/al-admin/public/javascripts/spinelz/window.js", "examples/al-admin/public/javascripts/spinelz/window_resizeEx.js", "examples/al-admin/public/javascripts/spinelz_lib/builder.js", "examples/al-admin/public/javascripts/spinelz_lib/controls.js", "examples/al-admin/public/javascripts/spinelz_lib/dragdrop.js", "examples/al-admin/public/javascripts/spinelz_lib/effects.js", "examples/al-admin/public/javascripts/spinelz_lib/json.js", "examples/al-admin/public/javascripts/spinelz_lib/prototype.js", "examples/al-admin/public/javascripts/spinelz_lib/resize.js", "examples/al-admin/public/javascripts/spinelz_lib/scriptaculous.js", "examples/al-admin/public/javascripts/spinelz_lib/slider.js", "examples/al-admin/public/javascripts/spinelz_lib/spinelz_util.js", "examples/al-admin/public/javascripts/spinelz_lib/unittest.js", "examples/al-admin/public/robots.txt", "examples/al-admin/public/stylesheets/account.css", "examples/al-admin/public/stylesheets/attributes.css", "examples/al-admin/public/stylesheets/base.css", "examples/al-admin/public/stylesheets/detail.css", "examples/al-admin/public/stylesheets/directory.css", "examples/al-admin/public/stylesheets/object-classes.css", "examples/al-admin/public/stylesheets/rails.css", "examples/al-admin/public/stylesheets/spinelz/accordion.css", "examples/al-admin/public/stylesheets/spinelz/balloon.css", "examples/al-admin/public/stylesheets/spinelz/calendar.css", "examples/al-admin/public/stylesheets/spinelz/datepicker.css", "examples/al-admin/public/stylesheets/spinelz/grid.css", "examples/al-admin/public/stylesheets/spinelz/menubar.css", "examples/al-admin/public/stylesheets/spinelz/modal.css", "examples/al-admin/public/stylesheets/spinelz/navPanel.css", "examples/al-admin/public/stylesheets/spinelz/selectableTable.css", "examples/al-admin/public/stylesheets/spinelz/sideBarBox.css", "examples/al-admin/public/stylesheets/spinelz/sortableTable.css", "examples/al-admin/public/stylesheets/spinelz/switcher.css", "examples/al-admin/public/stylesheets/spinelz/tabBox.css", "examples/al-admin/public/stylesheets/spinelz/timepicker.css", "examples/al-admin/public/stylesheets/spinelz/toolbar.css", "examples/al-admin/public/stylesheets/spinelz/treeview.css", "examples/al-admin/public/stylesheets/spinelz/window.css", "examples/al-admin/public/stylesheets/structure.css", "examples/al-admin/public/stylesheets/syntaxes.css", "examples/al-admin/public/stylesheets/users.css", "examples/al-admin/public/stylesheets/welcome.css", "examples/al-admin/script/about", "examples/al-admin/script/console", "examples/al-admin/script/dbconsole", "examples/al-admin/script/destroy", "examples/al-admin/script/generate", "examples/al-admin/script/performance/benchmarker", "examples/al-admin/script/performance/profiler", "examples/al-admin/script/performance/request", "examples/al-admin/script/plugin", "examples/al-admin/script/process/inspector", "examples/al-admin/script/process/reaper", "examples/al-admin/script/process/spawner", "examples/al-admin/script/runner", "examples/al-admin/script/server", "examples/al-admin/test/fixtures/users.yml", "examples/al-admin/test/functional/account_controller_test.rb", "examples/al-admin/test/functional/attributes_controller_test.rb", "examples/al-admin/test/functional/directory_controller_test.rb", "examples/al-admin/test/functional/object_classes_controller_test.rb", "examples/al-admin/test/functional/syntaxes_controller_test.rb", "examples/al-admin/test/functional/users_controller_test.rb", "examples/al-admin/test/functional/welcome_controller_test.rb", "examples/al-admin/test/run-test.sh", "examples/al-admin/test/test_helper.rb", "examples/al-admin/test/unit/user_test.rb", "examples/al-admin/vendor/plugins/exception_notification/README", "examples/al-admin/vendor/plugins/exception_notification/init.rb", "examples/al-admin/vendor/plugins/exception_notification/lib/exception_notifiable.rb", "examples/al-admin/vendor/plugins/exception_notification/lib/exception_notifier.rb", "examples/al-admin/vendor/plugins/exception_notification/lib/exception_notifier_helper.rb", "examples/al-admin/vendor/plugins/exception_notification/test/exception_notifier_helper_test.rb", "examples/al-admin/vendor/plugins/exception_notification/test/test_helper.rb", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_backtrace.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_environment.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_inspect_model.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_request.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_session.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/_title.rhtml", "examples/al-admin/vendor/plugins/exception_notification/views/exception_notifier/exception_notification.rhtml", "examples/config.yaml.example", "examples/example.der", "examples/example.jpg", "examples/groupadd", "examples/groupdel", "examples/groupls", "examples/groupmod", "examples/lpasswd", "examples/objects/group.rb", "examples/objects/ou.rb", "examples/objects/user.rb", "examples/ouadd", "examples/useradd", "examples/useradd-binary", "examples/userdel", "examples/userls", "examples/usermod", "examples/usermod-binary-add", "examples/usermod-binary-add-time", "examples/usermod-binary-del", "examples/usermod-lang-add", "lib/active_ldap.rb", "lib/active_ldap/action_controller/ldap_benchmarking.rb", "lib/active_ldap/acts/tree.rb", "lib/active_ldap/adapter/base.rb", "lib/active_ldap/adapter/jndi.rb", "lib/active_ldap/adapter/jndi_connection.rb", "lib/active_ldap/adapter/ldap.rb", "lib/active_ldap/adapter/ldap_ext.rb", "lib/active_ldap/adapter/net_ldap.rb", "lib/active_ldap/adapter/net_ldap_ext.rb", "lib/active_ldap/association/belongs_to.rb", "lib/active_ldap/association/belongs_to_many.rb", "lib/active_ldap/association/children.rb", "lib/active_ldap/association/collection.rb", "lib/active_ldap/association/has_many.rb", "lib/active_ldap/association/has_many_utils.rb", "lib/active_ldap/association/has_many_wrap.rb", "lib/active_ldap/association/proxy.rb", "lib/active_ldap/associations.rb", "lib/active_ldap/attributes.rb", "lib/active_ldap/base.rb", "lib/active_ldap/callbacks.rb", "lib/active_ldap/command.rb", "lib/active_ldap/configuration.rb", "lib/active_ldap/connection.rb", "lib/active_ldap/distinguished_name.rb", "lib/active_ldap/entry_attribute.rb", "lib/active_ldap/escape.rb", "lib/active_ldap/get_text.rb", "lib/active_ldap/get_text/parser.rb", "lib/active_ldap/get_text_fallback.rb", "lib/active_ldap/get_text_support.rb", "lib/active_ldap/helper.rb", "lib/active_ldap/human_readable.rb", "lib/active_ldap/ldap_error.rb", "lib/active_ldap/ldif.rb", "lib/active_ldap/object_class.rb", "lib/active_ldap/operations.rb", "lib/active_ldap/populate.rb", "lib/active_ldap/schema.rb", "lib/active_ldap/schema/syntaxes.rb", "lib/active_ldap/timeout.rb", "lib/active_ldap/timeout_stub.rb", "lib/active_ldap/user_password.rb", "lib/active_ldap/validations.rb", "lib/active_ldap/xml.rb", "po/en/active-ldap.po", "po/ja/active-ldap.po", "rails/README", "rails/init.rb", "rails/plugin/active_ldap/README", "rails/plugin/active_ldap/generators/README", "rails/plugin/active_ldap/generators/model_active_ldap/USAGE", "rails/plugin/active_ldap/generators/model_active_ldap/model_active_ldap_generator.rb", "rails/plugin/active_ldap/generators/model_active_ldap/templates/fixtures.yml", "rails/plugin/active_ldap/generators/model_active_ldap/templates/model_active_ldap.rb", "rails/plugin/active_ldap/generators/model_active_ldap/templates/unit_test.rb", "rails/plugin/active_ldap/generators/scaffold_active_ldap/scaffold_active_ldap_generator.rb", "rails/plugin/active_ldap/generators/scaffold_al/scaffold_al_generator.rb", "rails/plugin/active_ldap/init.rb", "rails_generators/model_active_ldap/USAGE", "rails_generators/model_active_ldap/model_active_ldap_generator.rb", "rails_generators/model_active_ldap/templates/model_active_ldap.rb", "rails_generators/model_active_ldap/templates/unit_test.rb", "rails_generators/scaffold_active_ldap/scaffold_active_ldap_generator.rb", "rails_generators/scaffold_active_ldap/templates/ldap.yml", "rails_generators/scaffold_al/scaffold_al_generator.rb", "test-unit/History.txt", "test-unit/Manifest.txt", "test-unit/README.txt", "test-unit/Rakefile", "test-unit/TODO", "test-unit/bin/testrb", "test-unit/lib/test/unit.rb", "test-unit/lib/test/unit/assertionfailederror.rb", "test-unit/lib/test/unit/assertions.rb", "test-unit/lib/test/unit/attribute.rb", "test-unit/lib/test/unit/autorunner.rb", "test-unit/lib/test/unit/collector.rb", "test-unit/lib/test/unit/collector/descendant.rb", "test-unit/lib/test/unit/collector/dir.rb", "test-unit/lib/test/unit/collector/load.rb", "test-unit/lib/test/unit/collector/objectspace.rb", "test-unit/lib/test/unit/color-scheme.rb", "test-unit/lib/test/unit/color.rb", "test-unit/lib/test/unit/diff.rb", "test-unit/lib/test/unit/error.rb", "test-unit/lib/test/unit/exceptionhandler.rb", "test-unit/lib/test/unit/failure.rb", "test-unit/lib/test/unit/fixture.rb", "test-unit/lib/test/unit/notification.rb", "test-unit/lib/test/unit/omission.rb", "test-unit/lib/test/unit/pending.rb", "test-unit/lib/test/unit/priority.rb", "test-unit/lib/test/unit/runner/console.rb", "test-unit/lib/test/unit/runner/emacs.rb", "test-unit/lib/test/unit/testcase.rb", "test-unit/lib/test/unit/testresult.rb", "test-unit/lib/test/unit/testsuite.rb", "test-unit/lib/test/unit/ui/console/outputlevel.rb", "test-unit/lib/test/unit/ui/console/testrunner.rb", "test-unit/lib/test/unit/ui/emacs/testrunner.rb", "test-unit/lib/test/unit/ui/testrunner.rb", "test-unit/lib/test/unit/ui/testrunnermediator.rb", "test-unit/lib/test/unit/ui/testrunnerutilities.rb", "test-unit/lib/test/unit/util/backtracefilter.rb", "test-unit/lib/test/unit/util/method-owner-finder.rb", "test-unit/lib/test/unit/util/observable.rb", "test-unit/lib/test/unit/util/procwrapper.rb", "test-unit/lib/test/unit/version.rb", "test-unit/sample/adder.rb", "test-unit/sample/subtracter.rb", "test-unit/sample/tc_adder.rb", "test-unit/sample/tc_subtracter.rb", "test-unit/sample/test_user.rb", "test-unit/sample/ts_examples.rb", "test-unit/test/collector/test-descendant.rb", "test-unit/test/collector/test-load.rb", "test-unit/test/collector/test_dir.rb", "test-unit/test/collector/test_objectspace.rb", "test-unit/test/run-test.rb", "test-unit/test/test-attribute.rb", "test-unit/test/test-color-scheme.rb", "test-unit/test/test-color.rb", "test-unit/test/test-diff.rb", "test-unit/test/test-emacs-runner.rb", "test-unit/test/test-fixture.rb", "test-unit/test/test-notification.rb", "test-unit/test/test-omission.rb", "test-unit/test/test-pending.rb", "test-unit/test/test-priority.rb", "test-unit/test/test_assertions.rb", "test-unit/test/test_error.rb", "test-unit/test/test_failure.rb", "test-unit/test/test_testcase.rb", "test-unit/test/test_testresult.rb", "test-unit/test/test_testsuite.rb", "test-unit/test/testunit-test-util.rb", "test-unit/test/ui/test_testrunmediator.rb", "test-unit/test/util/test-method-owner-finder.rb", "test-unit/test/util/test_backtracefilter.rb", "test-unit/test/util/test_observable.rb", "test-unit/test/util/test_procwrapper.rb", "test/al-test-utils.rb", "test/command.rb", "test/config.yaml.sample", "test/run-test.rb", "test/test_acts_as_tree.rb", "test/test_adapter.rb", "test/test_associations.rb", "test/test_attributes.rb", "test/test_base.rb", "test/test_base_per_instance.rb", "test/test_bind.rb", "test/test_callback.rb", "test/test_configuration.rb", "test/test_connection.rb", "test/test_connection_per_class.rb", "test/test_connection_per_dn.rb", "test/test_dn.rb", "test/test_find.rb", "test/test_groupadd.rb", "test/test_groupdel.rb", "test/test_groupls.rb", "test/test_groupmod.rb", "test/test_ldif.rb", "test/test_load.rb", "test/test_lpasswd.rb", "test/test_object_class.rb", "test/test_reflection.rb", "test/test_schema.rb", "test/test_syntax.rb", "test/test_user.rb", "test/test_user_password.rb", "test/test_useradd-binary.rb", "test/test_useradd.rb", "test/test_userdel.rb", "test/test_userls.rb", "test/test_usermod-binary-add-time.rb", "test/test_usermod-binary-add.rb", "test/test_usermod-binary-del.rb", "test/test_usermod-lang-add.rb", "test/test_usermod.rb", "test/test_validation.rb"]
  s.has_rdoc = true
  s.homepage = %q{http://rubyforge.org/projects/ruby-activeldap/}
  s.rdoc_options = ["--main", "lib/active_ldap.rb"]
  s.require_paths = ["lib"]
  s.requirements = ["ruby-ldap >= 0.8.2", "(Open)LDAP server"]
  s.rubyforge_project = %q{ruby-activeldap}
  s.rubygems_version = %q{1.3.1}
  s.summary = %q{Ruby/ActiveLdap is a object-oriented API to LDAP}
  s.test_files = ["test/test_acts_as_tree.rb", "test/test_adapter.rb", "test/test_associations.rb", "test/test_attributes.rb", "test/test_base.rb", "test/test_base_per_instance.rb", "test/test_bind.rb", "test/test_callback.rb", "test/test_configuration.rb", "test/test_connection.rb", "test/test_connection_per_class.rb", "test/test_connection_per_dn.rb", "test/test_dn.rb", "test/test_find.rb", "test/test_groupadd.rb", "test/test_groupdel.rb", "test/test_groupls.rb", "test/test_groupmod.rb", "test/test_ldif.rb", "test/test_load.rb", "test/test_lpasswd.rb", "test/test_object_class.rb", "test/test_reflection.rb", "test/test_schema.rb", "test/test_syntax.rb", "test/test_user.rb", "test/test_user_password.rb", "test/test_useradd-binary.rb", "test/test_useradd.rb", "test/test_userdel.rb", "test/test_userls.rb", "test/test_usermod-binary-add-time.rb", "test/test_usermod-binary-add.rb", "test/test_usermod-binary-del.rb", "test/test_usermod-lang-add.rb", "test/test_usermod.rb", "test/test_validation.rb"]

  if s.respond_to? :specification_version then
    current_version = Gem::Specification::CURRENT_SPECIFICATION_VERSION
    s.specification_version = 2

    if Gem::Version.new(Gem::RubyGemsVersion) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<activerecord>, [">= 0"])
      s.add_development_dependency(%q<hoe>, [">= 1.8.3"])
    else
      s.add_dependency(%q<activerecord>, [">= 0"])
      s.add_dependency(%q<hoe>, [">= 1.8.3"])
    end
  else
    s.add_dependency(%q<activerecord>, [">= 0"])
    s.add_dependency(%q<hoe>, [">= 1.8.3"])
  end
end
